<?php
#   TemaTres : aplicacin para la gestin de lenguajes documentales #       #
#                                                                        #
#   Copyright (C) 2004-2007 Diego Ferreyra tematres@r020.com.ar
#   Distribuido bajo Licencia GNU Public License, versin 2 (de junio de 1.991) Free Software Foundation
#   Version 0.96	
#  
###############################################################################################################
# llamada de funciones de gestion de terminos
#

if($_SESSION[$_SESSION["CFGURL"]][ssuser_nivel]>0){

# Alta de trmino subordinado
#1. Alta de trmino
#2. Alta de relacin
if($_POST[id_termino_sub]){
$arrayTerminos=explode("\n",doValue($_POST,FORM_LABEL_termino));
for($i=0; $i<sizeof($arrayTerminos);++$i){
		$new_termino=abm_tema('alta',$arrayTerminos[$i]);
		$new_relacion=do_r($id_termino_sub,$new_termino,"3");
		$tema=$new_termino;
		$_GET[id_sup]='';
		};
}

# Alta de trmino no preferido
#1. Alta de trmino
#2. Alta de relacin
if($_POST[id_termino_uf]){
$new_termino=abm_tema('alta',doValue($_POST,FORM_LABEL_termino));
$new_relacion=do_r($new_termino,$_POST[id_termino_uf],"4");
$tema=$_POST[id_termino_uf];
$_GET[id_uf]='';
}


# Alta de equivalencia de trmino
#1. Alta de trmino
#2. Alta de relacin
if($_POST[id_termino_eq]){
$new_termino=abm_tema('alta',doValue($_POST,FORM_LABEL_termino));
$new_relacion=do_r($new_termino,$_POST[id_termino_eq],$_POST[tipo_equivalencia]);
$tema=$_POST[id_termino_eq];
$_GET[id_eq]='';
}


# Alta de relacin entre trmino
if($_GET[sel_idtr]){
$new_relacion=do_terminos_relacionados($_GET[sel_idtr],$_GET[tema],"2");
$_GET[sel_idtr]='';

$MSG_ERROR_RELACION=$new_relacion[msg_error];
}

# Subordinacin de un trmino a otro
if($_GET[sel_idsuptr]){
	$new_relacion=do_r($_GET[sel_idsuptr],$tema,"3");
	$tema=$_GET[sel_idsuptr];
	$_GET[sel_idsuptr]='';

	$MSG_ERROR_RELACION=$new_relacion[msg_error];
};


# Borrado de  relacin
if($_GET[ridelete]){
borra_r($_GET[ridelete]);
};


# Borrado de  trmino
if($_GET[id_dete]){
borra_t($_GET[id_dete]);
};

# Alta de trmino
if($_POST[alta_t]=='new'){
$new_termino=abm_tema('alta',doValue($_POST,FORM_LABEL_termino));
$tema=$new_termino;
};

# Modificacin de trmino
if($_POST[edit_id_tema]){
$new_termino=abm_tema('mod',doValue($_POST,FORM_LABEL_termino),"$_POST[edit_id_tema]");
$tema=$new_termino;
};

# Alta de nota
if($_POST[altaNota]){
$tema=abmNota('A',"$_POST[idTema]",doValue($_POST,FORM_LABEL_tipoNota),doValue($_POST,FORM_LABEL_Idioma),doValue($_POST,FORM_LABEL_nota));
};

#Operaciones Mod y Borrado de notas
if($_POST[modNota]){
	# Modificacin de nota
	if($_POST[guardarCambioNota]==LABEL_Cambiar){
		$tema=abmNota('M',"$_POST[idTema]",doValue($_POST,FORM_LABEL_tipoNota),doValue($_POST,FORM_LABEL_Idioma),doValue($_POST,FORM_LABEL_nota),"$_POST[idNota]");
		};

	# Borrado de nota
	if($_POST[eliminarNota]==LABEL_EliminarNota){
		$tema=abmNota('B',"$_POST[idTema]","","","","$_POST[idNota]");
		};
};


# Cambio de estado de un trmino
if(($_GET[estado_id])&&($_GET[tema])){
	$cambio_estado=cambio_estado($_GET[tema],$_GET[estado_id]);
	$tema=$cambio_estado[tema_id];
	$MSG_ERROR_ESTADO=$cambio_estado[msg_error];
};

};// fin de llamdas de funciones de gestion



###################################################################################
##################      FUNCIONES DE ABM TERMINOS   ###############################
###################################################################################

function doArrayNota($array){
$arrayDatos=array("idTermino"=> doValue($array,"idTermino"),
		"idNota"=> doValue($array,"idNota"),
		"tipoNota"=> doValue($array,FORM_LABEL_tipoNota),
		"nota"=>doValue($array,FORM_LABEL_nota),
		);
return $arrayDatos;
};

function doArrayDatosUser($array){

$arrayDatos=array("nombres"=> doValue($array,FORM_LABEL_nombre),
		"apellido"=> doValue($array,FORM_LABEL_apellido),
		"mail"=>doValue($array,FORM_LABEL_mail),
		"pass"=> doValue($array,FORM_LABEL_pass),
		"orga"=> doValue($array,FORM_LABEL_orga),
		"id"=>doValue($array,FORM_LABEL_idUser)
		);
return $arrayDatos;
};


function doArrayDatosTesauro($array){

if(!doValue($array,FORM_LABEL_URI)){
	$array[FORM_LABEL_URI]="http://" . $_SERVER['HTTP_HOST']. rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
	};

$arrayDatos=array("titulo"=>doValue($array,FORM_LABEL_Titulo),
		"autor"=>doValue($array,FORM_LABEL_Autor),
		"idioma"=>doValue($array,FORM_LABEL_Idioma),
		"cobertura"=>doValue($array,FORM_LABEL_Cobertura),
		"keywords"=> doValue($array,FORM_LABEL_Keywords),
		"tipo"=> doValue($array,FORM_LABEL_TipoLenguaje),
		"url_base"=> doValue($array,FORM_LABEL_URI),
		"polijerarquia"=> doValue($array,FORM_LABEL_jeraquico),
		"cuando"=>doValue($array,FORM_LABEL_FechaAno).'-'.doValue($array,FORM_LABEL_FechaMes).'-'.doValue($array,FORM_LABEL_FechaDia),
		"id"=>doValue($array,FORM_LABEL_idTes)
		);

return $arrayDatos;
};


#
# ALTA DE TERMINOS RELACIONADOS (solo TR)
#
function do_terminos_relacionados($id_mayor,$id_menor,$t_relacion){
$evalRecursividad_ida=evalRelacionSuperior($id_mayor,'0',$id_menor);

$evalRecursividad_vuelta=evalRelacionSuperior($id_menor,'0',$id_mayor);

if(($evalRecursividad_ida==TRUE)&&($evalRecursividad_vuelta==TRUE)){
	#1. Alta de relacin de ida
	#2. Alta de relacin de vuelta
	$new_relacionIda=do_r($id_mayor,$id_menor,"2");
	$new_relacionVuelta=do_r($id_menor,$id_mayor,"2");
	$msg='';
	}else{
	$msg='<p class="error">'.MSGL_relacionIlegal.'</p>';;
	}

return array("id_tema"=>$id_menor,"msg_error"=>$msg);
};

#
# ALTA DE TERMINOS RELACIONADOS (todo tipo de relacion)
#
function do_r($id_mayor,$id_menor,$t_relacion){
GLOBAL $DBCFG;

$userId=$_SESSION[$_SESSION["CFGURL"]][ssuser_id];

$evalRecursividad=evalRelacionSuperior($id_mayor,'0',$id_menor);

# NO es una relacion recursiva
if($evalRecursividad==TRUE){
	$sql=SQL("insert","into $DBCFG[DBprefix]tabla_rel (id_mayor,id_menor,t_relacion,uid,cuando)
		values
		('$id_mayor','$id_menor','$t_relacion','$userId',now())");
	//es TG y hay que actualizar el arbol
	if($t_relacion=='3'){
		actualizaListaArbolAbajo($id_menor);
		}
	$msg='';
	}else{
	$msg='<p class="error">'.MSGL_relacionIlegal.'</p>';;
	};

return array("id_tema"=>$_POST[id_tema],"msg_error"=>$msg);
};



function actualizaListaArbolAbajo($tema_id){
actualizaArbolxTema($tema_id);
$sqlTerminosAfectados=SQLtieneTema($tema_id);
//Hay algo que actualizar
if($sqlTerminosAfectados[cant]){
	while($array=mysql_fetch_row($sqlTerminosAfectados[datos])){
		actualizaArbolxTema($array[0]);
	};
}
return $tema_id;
};


#
# BAJA FISICA DE TERMINOS
#
function borra_t($id_t){
GLOBAL $DBCFG;
$sqlCtrl=SQLverTerminosLibres($id_t);
if($sqlCtrl[cant]=='1')
	{
	$delete=SQL("delete","from $DBCFG[DBprefix]notas where id_tema='$id_t'");
	$delete=SQL("delete","from $DBCFG[DBprefix]tema where tema_id='$id_t'");
	}
	else return $MSG_ERROR_ELIMINAR;
};


#
# BAJA DE RELACIONES ENTRE TERMINOS
#
function borra_r($id_r){

GLOBAL $DBCFG;

$sql_dator=SQL("select","$DBCFG[DBprefix]tabla_rel.id,id_mayor,id_menor,t_relacion from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
$dator=mysql_fetch_array($sql_dator[datos]);

switch($dator[t_relacion]){
	case '2':
	$sql_id_delete=SQL("select","$DBCFG[DBprefix]tabla_rel.id
		from $DBCFG[DBprefix]tabla_rel
		where
		id_menor in ('$dator[id_menor]','$dator[id_mayor]')
		and id_mayor in ('$dator[id_menor]','$dator[id_mayor]')
		and t_relacion='$dator[t_relacion]'");

	while($id_delete=mysql_fetch_row($sql_id_delete[datos]))
		{
		$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_delete[0]'");
		}
	break;

	case '3':
	$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
	actualizaListaArbolAbajo($dator[id_menor]);
	break;


	case '4': //UF
	$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
	//Eliminar tambin el trmino
	//borra_t($dator[id_mayor]);
	break;

	case '5': //EQ
	$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
	//Eliminar tambin el trmino
	borra_t($dator[id_mayor]);
	break;

	case '6': //EQ
	$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
	//Eliminar tambin el trmino
	borra_t($dator[id_mayor]);
	break;

	case '7': //EQ
	$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
	//Eliminar tambin el trmino
	borra_t($dator[id_mayor]);
	break;


	case '8': //EQ
	$delete=SQL("delete","from $DBCFG[DBprefix]tabla_rel where id='$id_r'");
	//Eliminar tambin el trmino
	borra_t($dator[id_mayor]);
	break;
	};

};

#
# devuelve una lista separada por | del arbol/indice de un tema
#
function generaIndices($tema_id){
	$indice_temas=bucle_arriba($tema_id.'|',$tema_id);
return $indice_temas;
};



#
# actualiza la situacion de tema en el arbol/indice 
#
function actualizaArbolxTema($tema_id){
	GLOBAL $DBCFG;

	$este_tema_id=$tema_id;
	//Obtengo una cadena separada con | con el arbol inverso de un tema
	$tema_ids_inverso=generaIndices($tema_id);
	//Convierto en array y ordeno el arbol inverso de un tema
	$tema_ids_derecho=array_reverse(explode("|",$tema_ids_inverso));
	//Vuelvo a convertir en cadena separada por | con el arbol ordenado del termino
	foreach($tema_ids_derecho as $tema_id_cadena){
		$indice[$este_tema_id].='|'.$tema_id_cadena;
		}
	//Saco el ultimo caracter
	$esteindice=substr($indice[$este_tema_id],1);
	
	$sql=SQL("insert","into $DBCFG[DBprefix]indice values ('$tema_id','$esteindice')");
	if($sql[error]){
		$sql=SQL("update","$DBCFG[DBprefix]indice set indice='$esteindice' where tema_id='$tema_id'");
		}
return $tema_id;
};


#
# ALTA Y MODIFICACION DE TERMINOS
#
function abm_tema($do,$titu_tema,$tema_id=""){
GLOBAL $DBCFG;

$userId=$_SESSION[$_SESSION["CFGURL"]][ssuser_id];

//Es un trmino del vocabulario o una referencia a un trmino mapeado de otro vocabulario.
($_POST[ref_vocabulario_id]) ? $tesauro_id=$_POST[ref_vocabulario_id] :	$tesauro_id=$_SESSION[id_tesa];

$titu_tema=limpiaHTML($titu_tema);

if(strlen($titu_tema)>0)
	{
	switch($do)
		{
		case 'alta':
		$estado_id = (@$_POST[estado_id]) ? $_POST[estado_id] : '13';
		$sql=SQL("insert","into $DBCFG[DBprefix]tema (tema,tesauro_id,uid,cuando,estado_id,cuando_estado) values ('$titu_tema','$tesauro_id','$userId',now(),'$estado_id',now())");
		$tema_id=$sql[cant];
		break;

		case 'mod':
		$sql=SQL("update","$DBCFG[DBprefix]tema set tema='$titu_tema' ,uid_final='$userId',cuando_final=now() where tema_id='$tema_id'");
		break;
		};
	};

return $tema_id;
};

#
# Cambio de estado de un trmino
#
function cambio_estado($tema_id,$estado_id)
{
GLOBAL $DBCFG;
switch($estado_id)
	{
	case '13'://Aceptado / Aceptado
	//todos pueden ser aceptados
	$sql=SQL("update","$DBCFG[DBprefix]tema set estado_id='13' ,uid_final='$userId',cuando_estado=now() where tema_id='$tema_id' ");
	break;

	default :// '12' Candidato / Candidate o '14'://Rechazado / rejected 
	// slo trminos libres / only free terms
	$sqlCtrl=SQLverTerminosLibres($tema_id);
	if($sqlCtrl[cant]=='1')
		{
		$sql=SQL("update","$DBCFG[DBprefix]tema set estado_id='$estado_id' ,uid_final='$userId',cuando_estado=now() where tema_id='$tema_id'");
		}
		else
		{
		$msg_error = 	$msg='<p class="error">'.MSG_ERROR_ESTADO.'</p>';
		}
	break;
	}

return array("tema_id"=>$tema_id,"msg_error"=>$msg_error);
};
#
# ALTA, BAJA Y MODIFICACION DE NOTAS
#
function abmNota($do,$idTema,$tipoNota,$langNota,$nota,$idNota=""){

GLOBAL $DBCFG;
$userId=$_SESSION[$_SESSION["CFGURL"]][ssuser_id];
$nota=limpiaHTML($nota);
switch($do){
	case 'A':
	$sql=SQL("insert","into $DBCFG[DBprefix]notas (id_tema,tipo_nota,lang_nota,nota,cuando,uid) values ('$idTema','$tipoNota','$langNota','$nota',now(),'$userId')");
	break;

	case 'M':
	$sql=SQL("update","$DBCFG[DBprefix]notas set tipo_nota='$tipoNota',lang_nota='$langNota',nota='$nota',uid='$userId',cuando=now() where id='$idNota'");
	break;

	case 'B':
	$sql=SQL("delete","from $DBCFG[DBprefix]notas where id='$idNota'");
	break;
	};

return $idTema;
};


function admin_users($do,$user_id=""){

	GLOBAL $DBCFG;

	$userId=$_SESSION[$_SESSION["CFGURL"]][ssuser_id];

	switch($do){
		case 'actua':
		$arrayUser=doArrayDatosUser($_POST);

		$sql=SQL("update","$DBCFG[DBprefix]usuario
			SET apellido='$arrayUser[apellido]',
			nombres= '$arrayUser[nombres]',
			mail='$arrayUser[mail]',
			uid='$userId',
			pass= '$arrayUser[pass]',
			orga= '$arrayUser[orga]' WHERE id='$user_id'
			");
		break;

		case 'estado':

		$new_estado = ($_GET[estado]=='ACTIVO') ? 'BAJA' : 'ACTIVO';

		$sql=SQL("update","$DBCFG[DBprefix]usuario
			SET estado='$new_estado',
			uid='$userId',
			hasta=now()
			WHERE id='$user_id'
			");
		break;

		case 'alta':
		$arrayUser=doArrayDatosUser($_POST);
		$sql=SQL("insert","into $DBCFG[DBprefix]usuario (apellido, nombres, uid, cuando, mail, pass, orga, nivel, estado, hasta)
			VALUES
			('$arrayUser[apellido]', '$arrayUser[nombres]', '$userId', now(), '$arrayUser[mail]', '$arrayUser[pass]', '$arrayUser[orga]', '2', 'ACTIVO', now())
			");
		$user_id=$sql[cant];
		break;
		};
return $user_id;
};// fin de la funcion de administacion de usuarios

// fin de la funcion de datos propios de usuario


#
# # # # funciones de administracion # # # #
#

if($_SESSION[$_SESSION["CFGURL"]][ssuser_nivel]=='1'){
# cambios de configuracion y registro de vocabularios de referencia
function abm_vocabulario($do,$vocabulario_id=""){

GLOBAL $DBCFG;
$arrayTesa=doArrayDatosTesauro($_POST);
switch($do){
	case 'A':
	//Alta de vocabulario de referencia
	$sql=SQL("insert","into $DBCFG[DBprefix]config (titulo,autor,idioma,cobertura,keywords,tipo,polijerarquia,url_base,cuando) values ('$arrayTesa[titulo]','$arrayTesa[autor]','$arrayTesa[idioma]','$arrayTesa[cobertura]','$arrayTesa[keywords]','$arrayTesa[tipo]', '$arrayTesa[polijerarquia]', '$arrayTesa[url_base]','$arrayTesa[cuando]')");
	break;

	case 'M':
	//Modificacion de vocabulario de referencia y principal
	$sql=SQL("update","$DBCFG[DBprefix]config SET titulo='$arrayTesa[titulo]',
				autor='$arrayTesa[autor]',
				idioma='$arrayTesa[idioma]',
				cobertura='$arrayTesa[cobertura]',
				keywords= '$arrayTesa[keywords]',
				tipo= '$arrayTesa[tipo]',
				polijerarquia= '$arrayTesa[polijerarquia]',
				url_base= '$arrayTesa[url_base]',
				cuando='$arrayTesa[cuando]'
				where id='$vocabulario_id'");
	break;

	case 'B':
	//Eliminacion de un vocabulario de REFERENCIA
	break;
	}
return array("vocabulario_id"=>$vocabulario_id);
};




function optimizarTablas(){

	GLOBAL $DBCFG;
	$sql=SQLoptimizarTablas("`$DBCFG[DBprefix]notas` , `$DBCFG[DBprefix]tabla_rel` , `$DBCFG[DBprefix]tema`,`$DBCFG[DBprefix]indice`");

	$rows.='<div id="NA">'."\n\r";;
	$rows.='<dl>';
	while($array=mysql_fetch_array($sql)){
	$rows.='<dt>'.$array[Table].'</dt><dd> '.$array[Msg_text].'</dd>'."\n\r";
	}
	$rows.='</dl>';
	$rows.='</div>';

return $rows;
};


function HTMLdoMenuAdmin(){
	$row.='<div id="menu_edicion"><menu id="menu_editor">';
	$row.='<li><a href="#" onmouseover="montre(\'menu_ppal\');" onmouseout="cache(\'menu_ppal\');" >'.LABEL_Admin.'</a><menu id="menu_ppal" onmouseover="montre(\'menu_ppal\');" onmouseout="cache(\'menu_ppal\');">';
	$row.='<li><a title="'.ucfirst(LABEL_lcConfig).'" href="admin.php?vocabulario_id=list">'.ucfirst(LABEL_lcConfig).'</a></li>';
	$row.='<li><a title="'.ucfirst(MENU_Usuarios).'" href="admin.php?user_id=list">'.ucfirst(MENU_Usuarios).'</a></li>';
	$row.='<li><a title="'.ucfirst(LABEL_export).'" href="admin.php?doAdmin=export">'.ucfirst(LABEL_export).'</a></li>';
	$row.='<li><a title="'.ucfirst(MENU_DatosTesauro).'" href="admin.php?opTbl=TRUE">'.ucfirst(LABEL_OptimizarTablas).'</a></li>';
	$row.='    </menu></li>';
	$row.='   </li></menu>';
	$row.='</div>';

return $row;
};

}; // fin funciones de administracion

#
# Vista de trminos libres
#

function verTerminosLibres(){

	$sql=SQLverTerminosLibres();

	$rows.=do_menuABM("","");
	$rows.='<div><h1>'.ucfirst(LABEL_terminosLibres).' ('.$sql[cant].') </h1>';
	$rows.='<ul>';
	if($sql[cant]==0){
		$rows.='<li>'.ucfirst(MSG_noTerminosLibres).'<li/>';
	}else{
		while ($array = mysql_fetch_array($sql[datos])){
		$rows.='<li><a title="'.$array[tema].'" href="index.php?tema='.$array[id].'">'.$array[tema].'</a><li/>';
		};
	}
	$rows.='</ul>';
	$rows.='</div>';
return $rows;
};

#
# Vista de trminos libres
#

function verTerminosRepetidos(){

$sql=SQLverTerminosRepetidos();

$rows.=do_menuABM("","");
$rows.='<div><h1>'.ucfirst(LABEL_terminosRepetidos).' ('.$sql[cant].') </h1>';
$rows.='<ul>';

if($sql[cant]==0){
	$rows.='<li>'.ucfirst(MSG_noTerminosRepetidos).'<li/>';
	}else{
	while($array = mysql_fetch_array($sql[datos])){
		$rows.='<li> <a title="'.$array[tema].'" href="index.php?'.FORM_LABEL_buscar.'='.$array[tema].'&tipo=E">'.$array[tema].'</a> ('.$array[cant].')<li/>';
		}
};
$rows.='</ul>';
$rows.='</div>';


return $rows;
};

###########################################################################
##########  HTML DE GESTION #############################################
###########################################################################
#
# Armado de tabla de trminos segn usuarios
#
function doBrowseTermsFromUser($user_id,$ord=""){

GLOBAL $MONTHS;

$sql=SQLlistTermsfromUser($user_id,$ord);

$rows.='<table cellpadding="0" cellspacing="0" summary="'.ucfirst(LABEL_auditoria).'">'."\n\r";
$rows.='<tbody>'."\n\r";
while($array=mysql_fetch_array($sql[datos])){
	$user_id=$array[id_usuario];
	$apellido=$array[apellido];
	$nombres=$array[nombres];
	$fecha_termino=do_fecha($array[cuando]);
	$rows.='<tr>'."\n\r";
	$rows.='<td class="izq"><a href="index.php?tema='.$array[id_tema].'" title="'.LABEL_verDetalle.LABEL_Termino.'">'.$array[tema].'</a></td>'."\n\r";
	$rows.='<td>'.$fecha_termino[dia].' / '.$fecha_termino[descMes].' / '.$fecha_termino[ano].'</td>'."\n\r";
	$rows.='</tr>'."\n\r";
	};
$rows.='</tbody>'."\n\r";

$rows.='<thead>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<th class="izq" colspan="3"><a href="sobre.php">'.ucfirst(LABEL_auditoria).'</a> &middot; <a href="admin.php?user_id='.$user_id.'"  title="'.LABEL_verDetalle.$apellido.', '.$nombres.'">'.$apellido.', '.$nombres.'</a>: '.$sql[cant].' trminos</th>'."\n\r";
$rows.='</tr>'."\n\r";

$rows.='<tr>'."\n\r";
$rows.='<th><a href="sobre.php?user_id='.$user_id.'&ord=T" title="'.LABEL_ordenar.' '.LABEL_Termino.'">'.ucfirst(LABEL_Termino).'</a></th>'."\n\r";
$rows.='<th><a href="sobre.php?user_id='.$user_id.'&ord=F" title="'.LABEL_ordenar.' '.LABEL_Fecha.'">'.ucfirst(LABEL_Fecha).'</a></th>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='</thead>'."\n\r";


$rows.='<tfoot>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<td class="izq">'.ucfirst(LABEL_TotalTerminos).'</td>'."\n\r";
$rows.='<td>'.$sql[cant].'</td>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='</tfoot>'."\n\r";

$rows.='</table>        '."\n\r";
return $rows;
};


#
# Lista de usuarios
#
function HTMLListaUsers(){

$sqlListaUsers=SQLdatosUsuarios();

$rows.='<table cellpadding="0" cellspacing="0" summary="'.MENU_Usuarios.'" >'."\n\r";
$rows.='<thead>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<th class="izq" colspan="4">'.MENU_Usuarios.' &middot; [<a href="admin.php?user_id=new" title="'.MENU_NuevoUsuario.'">'.MENU_NuevoUsuario.'</a>]</th>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_apellido).', '.ucfirst(LABEL_nombre).'</th>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_orga).'</th>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_Fecha).'</th>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_Terminos).'</th>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='</thead>'."\n\r";

$rows.='<tbody>'."\n\r";

while($listaUsers=mysql_fetch_array($sqlListaUsers[datos])){
	$fecha_alta=do_fecha($listaUsers[cuando]);
	$rows.='<tr>'."\n\r";
	$rows.='<td class="izq"><a href="admin.php?user_id='.$listaUsers[id].'" title="'.LABEL_detallesUsuario.'">'.$listaUsers[apellido].', '.$listaUsers[nombres].'</a></td>'."\n\r";
	$rows.='<td class="izq">'.$listaUsers[orga].'</td>'."\n\r";
	$rows.='<td>'.$fecha_alta[dia].'-'.$fecha_alta[descMes].'-'.$fecha_alta[ano].' ('.arrayReplace(array("ACTIVO","BAJA"),array(LABEL_User_Habilitado,LABEL_User_NoHabilitado),$listaUsers[estado]). ')</td>'."\n\r";
	if($listaUsers[cant_terminos]>0){
		$rows.='<td><a href="sobre.php?user_id='.$listaUsers[id].'" title="'.LABEL_Detalle.'">'.$listaUsers[cant_terminos].'</a></td>'."\n\r";
		}else{
		$rows.='<td>'.$listaUsers[cant_terminos].'</td>'."\n\r";
		}
	$rows.='</tr>'."\n\r";
	};

$rows.='</tbody>'."\n\r";
$rows.='<tfoot>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<td class="izq">'.ucfirst(LABEL_TotalUsuarios).'</td>'."\n\r";
$rows.='<td colspan="3">'.$sqlListaUsers[cant].'</td>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='</tfoot>'."\n\r";

$rows.='</table>        '."\n\r";

return $rows;
};


#
# lista de vocabularios
#
function HTMLlistaVocabularios(){

$sql=SQLdatosVocabulario();

$rows.='<table cellpadding="0" cellspacing="0" summary="'.LABEL_lcConfig.'" >'."\n\r";
$rows.='<thead>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<th class="izq" colspan="3">'.LABEL_lcConfig.' &middot; [<a href="admin.php?vocabulario_id=0" title="'.MENU_NuevoVocabularioReferencia.'">'.LABEL_Agregar.' '.LABEL_vocabulario_referencia.'</a>]</th>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_Titulo).'</th>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_Autor).'</th>'."\n\r";
$rows.='<th>'.ucfirst(LABEL_tipo_vocabulario).'</th>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='</thead>'."\n\r";
$rows.='<tbody>'."\n\r";

while($array=mysql_fetch_array($sql[datos])){
	$fecha_alta=do_fecha($listaUsers[cuando]);
	$rows.='<tr>'."\n\r";
	$rows.='<td class="izq"><a href="admin.php?vocabulario_id='.$array[vocabulario_id].'" title="'.MENU_DatosTesauro.' '.$array[titulo].'">'.$array[titulo].'</a> / '.$array[idioma].'</td>'."\n\r";
	$rows.='<td class="izq">'.$array[autor].'</td>'."\n\r";
	if($array[vocabulario_id]=='1'){
		$rows.='<td>'.LABEL_vocabulario_principal.'</td>'."\n\r";
		}else{
		$rows.='<td>'.LABEL_vocabulario_referencia.'</td>'."\n\r";
		}
	
	$rows.='</tr>'."\n\r";
	};

$rows.='</tbody>'."\n\r";

$rows.='<tfoot>'."\n\r";
$rows.='<tr>'."\n\r";
$rows.='<td colspan="3">'.$sql[cant].'</td>'."\n\r";
$rows.='</tr>'."\n\r";
$rows.='</tfoot>'."\n\r";
$rows.='</table>        '."\n\r";

return $rows;
};


function HTMLformExport(){
$LABEL_jtxt=MENU_ListaSis.' (txt)';
$LABEL_abctxt=MENU_ListaAbc.' (txt)';

$rows.='<h1>'.ucfirst(LABEL_Admin).'</h1><fieldset>';
$rows.='    <legend>'.ucfirst(LABEL_export).'</legend>';
$rows.='<form class="formdiv" name="export" action="xml.php" method="GET">';
$rows.='<label for="dis">'.ucfirst(FORM_LABEL_format_export).'</label><br />';
$rows.='<select id="dis" name="dis">';
$rows.='<optgroup label="'.FORM_LABEL_format_export.'">';
$rows.=doSelectForm(array("jtxt#$LABEL_jtxt","txt#$LABEL_abctxt","zline#Zthes","rfile#Skos-Core","rxtm#TopicMap","siteMap#SiteMap"),"$_GET[dis]");
$rows.='</optgroup>';
$rows.='</select>';
$rows.='<br /><input type="submit"  name="boton" value="'.LABEL_Enviar.'"/>';
$rows.='</form>';
$rows.='  </fieldset>';

return $rows;
};


// 
// Exportaciones totales del vocabularios
// 

function doTotalZthes($tipoEnvio){

$time_start = time();

@set_time_limit(900);

switch($tipoEnvio){
	case 'line':
	$sql=SQLIdTerminosValidos();

		header ('content-type: text/xml');
		outputCosas('<?xml version="1.0" encoding="ISO-8859-1"?>');
		outputCosas('<!DOCTYPE Zthes SYSTEM "http://zthes.z3950.org/xml/zthes-05.dtd">');
		outputCosas('<?xml-stylesheet href="http://'.$_SERVER['HTTP_HOST']. rtrim(dirname($_SERVER['PHP_SELF']), '/\\').'/css/zthes.xsl" type="text/xsl"?>');
		outputCosas('        <Zthes>');
		while($array=mysql_fetch_row($sql[datos])){
		outputCosas(do_nodo_zthes($array[0],"TRUE"));
		};
		outputCosas('</Zthes>');

	break;

	#enviar como archivo  !!!no implementado!!!
	case 'file':

	$sql=SQLIdTerminosValidos();
	while($array=mysql_fetch_row($sql[datos])){

		$time_now = time();
		if ($time_start >= $time_now + 10) {
			$time_start = $time_now;
			header('X-pmaPing: Pong');
		};

		$zthes.=do_nodo_zthes($array[0],"TRUE");
	};

		$meta_tag.='<?xml version="1.0" encoding="ISO-8859-1"?>';
		$meta_tag.='<!DOCTYPE Zthes SYSTEM "http://zthes.z3950.org/xml/zthes-05.dtd">'."\n\r";
		$meta_tag.='<Zthes>'."\n\r";
		$meta_tag.=$zthes;
		$meta_tag.='</Zthes>'."\n\r";

	$filname=string2url($_SESSION[CFGTitulo]).'.xml';
	return sendFile("$meta_tag","$filname");

	break;
	};

};



function doTotalSkos($tipoEnvio){

$time_start = time();

@set_time_limit(900);

switch($tipoEnvio){
	case 'line':

	# Top term del esquema
	$sqlTT=SQLverTopTerm();
	while ($arrayTT=mysql_fetch_array($sqlTT[datos])){
		$skos_TT.='<skos:hasTopConcept rdf:nodeID="tema'.$arrayTT[id].'"/>'."\n\r";
		};

		header ('content-type: text/xml');
		outputCosas('<?xml version="1.0" encoding="ISO-8859-1"?>');
		outputCosas('<rdf:RDF');
		outputCosas('        xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"');
		outputCosas('        xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"');
		outputCosas('        xmlns:skos="http://www.w3.org/2004/02/skos/core#"');
		outputCosas('        xmlns:dct="http://purl.org/dc/terms/"');
		outputCosas('        xmlns:dc="http://purl.org/dc/elements/1.1/">');
		outputCosas('<skos:ConceptScheme rdf:nodeID="tematres">');
		outputCosas('     <dc:title>'.$_SESSION[CFGTitulo].'</dc:title>');
		outputCosas('     <dc:creator>'.$_SESSION[CFGAutor].'</dc:creator>');
		outputCosas('     <dc:subject>'.$_SESSION[CFGKeywords].'</dc:subject>');
		outputCosas('     <dc:description>'.$_SESSION[CFGCobertura].'</dc:description>');
		outputCosas('     <dc:publisher>'.$_SESSION[CFGAutor].'</dc:publisher>');
		outputCosas('     <dc:date>'.$_SESSION[CFGCreacion].'</dc:date>');
		outputCosas('     <dc:language>'.LANG.'</dc:language>');
		outputCosas($skos_TT);
		outputCosas('</skos:ConceptScheme>');

$sql=SQLIdTerminosValidos();
while($array=mysql_fetch_row($sql[datos]))
	{
	outputCosas(do_nodo_skos($array[0]));
	};
outputCosas('</rdf:RDF>');
break;

#enviar como archivo  !!!no implementado!!!
case 'file':
	$sql=SQLIdTerminosValidos();

	while($array=mysql_fetch_row($sql[datos])){

	#Mantener vivo el navegador
	$time_now = time();
	if ($time_start >= $time_now + 10) {
		$time_start = $time_now;
		header('X-pmaPing: Pong');
	};

	$skosNodos.=do_nodo_skos($array[0]);
	};

	$meta_tag=do_skos($skosNodos);

	$filname=string2url($_SESSION[CFGTitulo]).'.rdf';
	return sendFile("$meta_tag","$filname");
	break;
	};

};



function doTotalTopicMap($tipoEnvio){

$time_start = time();

@set_time_limit(900);

switch($tipoEnvio){
	case 'line':
	$sql=SQLIdTerminosValidos();

	header ('content-type: text/xml');
	outputCosas('<?xml version="1.0" encoding="ISO-8859-1"?>');
	outputCosas(XTMheader);
	outputCosas(doTerminosXTM());
	outputCosas(doRelacionesXTM());
	outputCosas('</topicMap>');
	break;

	#enviar como archivo
	case 'file':
	header ('content-type: text/xml');
	$row.='<?xml version="1.0" encoding="ISO-8859-1"?>';
	$row.=XTMheader;

	$rowTerminos=doTerminosXTM($tema_id);
	$rowRelaciones=doRelacionesXTM($tema_id);
	$rowFinal='</topicMap>';

	$rows=$row.$rowTerminos.$rowRelaciones.$rowFinal;

	$filname=string2url($_SESSION[CFGTitulo]).'.xtm';
	sendFile("$rows","$filname");
	break;
	};

};


#
# Armado de salida SiteMap Google
#
function do_sitemap(){

$time_start = time();
@set_time_limit(900);

header ('content-type: text/xml');
$rows='<?xml version="1.0" encoding="UTF-8"?>';
$rows.='<urlset xmlns="http://www.google.com/schemas/sitemap/0.84">';
$sql=SQLIdTerminosValidos();

while ($array=mysql_fetch_array($sql[datos])){
	$time_now = time();
	if ($time_start >= $time_now + 10) {
		$time_start = $time_now;
		header('X-pmaPing: Pong');
	};

	($array[cuando_final]>0) ? $fecha = do_fecha($array[cuando_final]) : $fecha = do_fecha($array[cuando]);
	
	$rows.='<url>'."\n\r";
	$rows.='    <loc>'.$_SESSION[CFGURL].'?tema='.$array[id].'</loc>';
	$rows.='    <lastmod>'.$fecha[ano].'-'.$fecha[mes].'-'.$fecha[dia].'</lastmod>';
	$rows.='    <changefreq>weekly</changefreq>';
	$rows.='    <priority>0.7</priority>';
	$rows.='</url>'."\n\r";
	};
$rows.=' </urlset>';

$filname=string2url($_SESSION[CFGTitulo]).'_sitemap.xml';
sendFile("$rows","$filname");
};




function txtAlfabetico(){

$txt=ucfirst(LABEL_Titulo).': '.$_SESSION["CFGTitulo"]."\n";
$txt.=ucfirst(LABEL_Autor).': '.$_SESSION["CFGAutor"]."\n";
$txt.=ucfirst(LABEL_Keywords).': '.$_SESSION["CFGKeywords"]."\n";
$txt.=ucfirst(LABEL_Cobertura).': '.$_SESSION["CFGCobertura"]."\n";
$txt.=LABEL_URI.': '.$_SESSION["CFGURL"]."\n";
$txt.=ucfirst(LABEL_Version).': '.$_SESSION["CFGVersion"]."\n";
$txt.="__________________________________________________________________________\n\r";

//Lista de todos los trminos
$sql=SQLlistaTemas();
while($arrayTema=mysql_fetch_array($sql[datos])){

	#Mantener vivo el navegador
	$time_now = time();
	if ($time_start >= $time_now + 10) {
		$time_start = $time_now;
		header('X-pmaPing: Pong');
	};

	// Diferenciar entre trminos preferidos y trminos no preferidos o referencias
	if($arrayTema[t_relacion])// Si es no preferido o refencia: mostrar preferido y referido
	{
	//Remisiones de equivalencias y no preferidos
	$sqlNoPreferidos=SQLterminosValidosUF($arrayTema[id]);
	while($arrayNoPreferidos=mysql_fetch_array($sqlNoPreferidos[datos])){

		$acronimo=arrayReplace ( array("4","5","7","8"),array(USE_termino,EQ_acronimo,EQP_acronimo,NEQ_acronimo),$arrayNoPreferidos[t_relacion]);
	
		$referencia_mapeo = ($arrayNoPreferidos[vocabulario_id]!=='1') ? (' ('.$arrayNoPreferidos[titulo].' / '.$arrayNoPreferidos[idioma].')') : ('')."\n";

		$txt.="\n".$arrayTema[tema] . $referencia_mapeo ;
		$txt.='	'.$acronimo.': '.$arrayNoPreferidos[tema_pref]."\n";
		};


	} else {// Si es preferido: mostar notas y relaciones
	$txt.="\n".$arrayTema[tema]."\n";

	$txt.=LABEL_fecha_creacion.': '.$arrayTema[cuando]."\n";
	if($arrayTema[cuando_final]>$arrayTema[cuando])	{$txt.=LABEL_fecha_modificacion.': '.$arrayTema[cuando_final]."\n";};

	//Notas
	$sqlNotas=SQLdatosTerminoNotas($arrayTema[id],array("NB","NH","NA","NC"));
	while($arrayNotas=mysql_fetch_array($sqlNotas[datos])){
		$acronimo=arrayReplace ( array("NB","NH","NA","NC"),array(NB_acronimo,NH_acronimo,NA_acronimo,NC_acronimo),$arrayNotas[tipo_nota]);
		$txt.='	'.$acronimo.': '.html2txt($arrayNotas[nota])."\n";
		};

	//Relaciones
	$sqlRelaciones=SQLverTerminoRelaciones($arrayTema[id]);
	while($arrayRelaciones=mysql_fetch_array($sqlRelaciones[datos])){
		$acronimo=arrayReplace ( array("2","3","4"),array(TR_acronimo,TG_acronimo,UP_acronimo),$arrayRelaciones[t_relacion]);
		$txt.='	'.$acronimo.': '.$arrayRelaciones[tema]."\n";
		};

	//Terminos especificos
	$SQLTerminosE=SQLverTerminosE($arrayTema[id]);
	while($arrayTE=mysql_fetch_array($SQLTerminosE[datos])){
		$txt.='	'.TE_acronimo.': '.$arrayTE[tema]."\n";
		};
	}
}

$filname=string2url($_SESSION[CFGTitulo].' '.MENU_ListaAbc).'.txt';

return sendFile("$txt","$filname");
};


function txtJerarquico(){

$txt=ucfirst(LABEL_Titulo).': '.$_SESSION["CFGTitulo"]."\n";
$txt.=ucfirst(LABEL_Autor).': '.$_SESSION["CFGAutor"]."\n";
$txt.=ucfirst(LABEL_Keywords).': '.$_SESSION["CFGKeywords"]."\n";
$txt.=ucfirst(LABEL_Cobertura).': '.$_SESSION["CFGCobertura"]."\n";
$txt.=LABEL_URI.': '.$_SESSION["CFGURL"]."\n";
$txt.=ucfirst(LABEL_Version).': '.$_SESSION["CFGVersion"]."\n";
$txt.="__________________________________________________________________________\n\r";

//Lista de trminos topes
$sql=SQLverTopTerm();
while($arrayTema=mysql_fetch_array($sql[datos])){

#Mantener vivo el navegador
$time_now = time();
if ($time_start >= $time_now + 10) {
	$time_start = $time_now;
	header('X-pmaPing: Pong');
};
// es preferido
$txt.="\n".$arrayTema[tema]."\n";
//Terminos especificos
$txt.=TXTverTE($arrayTema[id],"0");
}

$filname=string2url($_SESSION[CFGTitulo].' '.MENU_ListaSis).'.txt';

return sendFile("$txt","$filname");
};


function TXTverTE($tema_id,$i_profundidad){

GLOBAL $CFG;
$i_profundidad=++$i_profundidad;

$sql=SQLverTerminosE($tema_id);

//Contador de profundidad de TE desde la raz
	while($array=mysql_fetch_array($sql[datos])){
		//calculo de sangra
		$sangria='';
		for($i="1"; $i<="$i_profundidad"; ++$i){
			$sangria.=' .';
			};

		//si tiene TEs
		if($array[id_te]){
			$txt.=$sangria.$array[tema]."\n";
			$txt.=TXTverTE($array[id_tema],$i_profundidad);
		}else{
		$txt.=$sangria.$array[tema]."\n";
		};
	};
return $txt;
};

?>