<?php
#   TemaTres : aplicacin para la gestin de lenguajes documentales #       #
#                                                                        #
#   Distribuido bajo Licencia GNU Public License, versin 2 (de junio de 1.991) Free Software Foundation
#   Version 0.97
#
###############################################################################################################
#


define("LANG","es");

define("TR_acronimo","TR");
define("TE_acronimo","TE");
define("TG_acronimo","TG");
define("UP_acronimo","UP");

define("TR_termino","Trmino relacionado");
define("TE_termino","Trmino especfico");
define("TG_termino","Trmino general");
define("UP_termino","Usado por");
/* v 9.5 */
define("USE_termino","USE");

define("MENU_ListaSis","Lista sistemtica");
define("MENU_ListaAbc","Lista alfabtica");
define("MENU_Sobre","Sobre...");
define("MENU_Inicio","Inicio");

define("MENU_MiCuenta","Mi cuenta");
define("MENU_Usuarios","Usuarios");
define("MENU_NuevoUsuario","Nuevo usuario");
define("MENU_DatosTesauro","Datos del vocabulario");

define("MENU_AgregarT","Agregar Trmino");
define("MENU_EditT","Editar Trmino");
define("MENU_BorrarT","Eliminar Trmino");
define("MENU_AgregarTG","Subordinar a un trmino");
define("MENU_AgregarTE","Trmino subordinado");
define("MENU_AgregarTR","Trmino relacionado");
define("MENU_AgregarUP","Trmino no preferido");



define("MENU_MisDatos","Mis datos");
define("MENU_Caducar","Caducar");
define("MENU_Habilitar","Habilitar");
define("MENU_Salir","Salir");

define("LABEL_Menu","Men");
define("LABEL_Opciones","Opciones");
define("LABEL_Admin","Administracin");
define("LABEL_Agregar","Agregar");
define("LABEL_editT","Modificar trmino ");
define("LABEL_EditorTermino","Editor de trmino");
define("LABEL_Termino","Trmino");
define("LABEL_NotaAlcance","Nota de alcance");
define("LABEL_AgregarT","Alta de trmino");
define("LABEL_AgregarTG","Subordinar %s a trmino superior");
define("LABEL_AgregarTE","Alta de un trmino subordinado a ");
define("LABEL_AgregarUP","Alta de un trmino no preferido de ");
define("LABEL_AgregarTR","Alta de trmino relacionado con ");
define("LABEL_EliminarTE","Eliminar trmino");
define("LABEL_Detalle","detalles");
define("LABEL_EditarNota","editar nota");


define("LABEL_Autor","Autor");
define("LABEL_URI","URI");
define("LABEL_Version","Generado por");
define("LABEL_Idioma","Idioma");
define("LABEL_Fecha","Fecha de creacin");
define("LABEL_Keywords","Palabras clave");
define("LABEL_TipoLenguaje","Tipo de lenguaje");
define("LABEL_Cobertura","Cobertura");
define("LABEL_Terminos","trminos");
define("LABEL_RelTerminos","relaciones entre trminos");
define("LABEL_TerminosUP","trminos no preferidos");

define("LABEL_BuscaTermino","Buscar trmino");
define("LABEL_Buscar","Buscar");
define("LABEL_Enviar","Enviar");
define("LABEL_Cambiar","Guardar cambios");
define("LABEL_Anterior","anterior");
define("LABEL_AdminUser","Administracin de usuarios");
define("LABEL_DatosUser","Datos del usuario");
define("LABEL_Acciones","Acciones realizadas");
define("LABEL_verEsquema","ver esquema");
define("LABEL_actualizar","Actualizar");
define("LABEL_terminosLibres","Trminos libres");
define("LABEL_busqueda","Bsqueda");
define("LABEL_borraRelacion","eliminar relacin");

define("MSG_ResultBusca","trmino/s encontrados para la bsqueda");
define("MSG_ResultLetra","Letra");
define("MSG_ResultCambios","Los cambios han sido realizados con &eacute;xito.");
define("MSG_noUser","<p>Usuario no registrado</p>");

define("FORM_JS_check","Por favor revise los datos de ");
define("FORM_JS_confirm","Esta seguro de que desea eliminar el termino o la relacin?");
define("FORM_JS_pass","_clave");
define("FORM_JS_confirmPass","_repetir_clave");

define("FORM_LABEL_termino","_termino");
define("FORM_LABEL_buscar","_expresion_de_busqueda");
define("FORM_LABEL_buscarTermino","_termino_relacionado");

define("FORM_LABEL_nombre","_nombre");
define("FORM_LABEL_apellido","_apellido");
define("FORM_LABEL_mail","_correo_electronico");
define("FORM_LABEL_pass","_clave");
define("FORM_LABEL_repass","_confirmar_clave");
define("FORM_LABEL_orga","orga");

define("LABEL_nombre","nombre");
define("LABEL_apellido","apellido");
define("LABEL_mail","correo electrnico");
define("LABEL_pass","clave");
define("LABEL_repass","confirmar clave");
define("LABEL_orga","organizacin");

define("LABEL_lcConfig","configuracin");
define("LABEL_lcDatos","datos del vocabulario");

define("LABEL_Titulo","Ttulo");

define("FORM_LABEL_Titulo","_titulo");
define("FORM_LABEL_Autor","_autor");
define("FORM_LABEL_URI","_URI");
define("FORM_LABEL_Idioma","Idioma");
define("FORM_LABEL_FechaDia","dia");
define("FORM_LABEL_FechaMes","mes");
define("FORM_LABEL_FechaAno","ano");
define("FORM_LABEL_Keywords","keywords");
define("FORM_LABEL_TipoLenguaje","language_type");
define("FORM_LABEL_Cobertura","scope");
define("FORM_LABEL_Terminos","terms");
define("FORM_LABEL_RelTerminos","relaciones entre trminos");
define("FORM_LABEL_TerminosUP","trminos no preferidos");
define("FORM_LABEL_Guardar","Guardar");

define("LABEL_verDetalle","ver detalles de ");
define("LABEL_verTerminosLetra","ver trminos iniciados con ");

define("LABEL_NB","Nota bibliogrfica");
define("LABEL_NH","Nota histrica");
define("LABEL_NA","Nota de alcance"); /* version 0.9.1 */
define("LABEL_NP","Nota privada");    /* version 0.9.1 */

define("LABEL_EditorNota","Editor de notas");
define("LABEL_EditorNotaTermino","Notas del trmino ");
define("LABEL_tipoNota","tipo de nota");
define("FORM_LABEL_tipoNota","tipo_nota");
define("LABEL_nota","nota");
define("FORM_LABEL_nota","_nota");
define("LABEL_EliminarNota","Eliminar nota");

define("LABEL_OptimizarTablas","Optimizar tablas");
define("LABEL_TotalZthesLine","exportar en Zthes");

/* v 9.2 */
define("LABEL_negrita","negrita");
define("LABEL_italica","itlica");
define("LABEL_subrayado","subrayado");
define("LABEL_textarea","espacio para notas");
define("MSGL_relacionIlegal","Relacin no permitida entre trminos");

/* v 9.3 */
define("LABEL_fecha_modificacion","modificacin");
define("LABEL_TotalUsuarios","total de usuarios");
define("LABEL_TotalTerminos","total de trminos");
define("LABEL_ordenar","ordenar por");
define("LABEL_auditoria","auditora de trminos");
define("LABEL_dia","da");
define("LABEL_mes","mes");
define("LABEL_ano","ao");
define("LABEL_terminosRepetidos","trminos repetidos");
define("MSG_noTerminosLibres","no existen trminos libres");
define("MSG_noTerminosRepetidos","no existen trminos repetidos");
define("LABEL_TotalSkosLine","exportar en Skos-Core");

$MONTHS=array("01"=>Ene,
              "02"=>Feb,
              "03"=>Mar,
              "04"=>Abr,
              "05"=>May,
              "06"=>Jun,
              "07"=>Jul,
              "08"=>Ago,
              "09"=>Sep,
              "10"=>Oct,
              "11"=>Nov,
              "12"=>Dic
              );

/* v 9.4 */
define("LABEL_SI","SI");
define("LABEL_NO","NO");
define("FORM_LABEL_jeraquico","polijerarquia");
define("LABEL_jeraquico","Polijerarqua");
define("LABEL_terminoLibre","trmino libre");

/* v 9.5 */
define("LABEL_URL_busqueda","Buscar %s en: ");


/* v 9.6 */
define("LABEL_relacion_vocabulario","relacin con otro vocabulario");
define("FORM_LABEL_relacion_vocabulario","equivalencia");
define("FORM_LABEL_nombre_vocabulario","vocabulario de referencia");
define("LABEL_vocabulario_referencia","vocabulario de referencia");
define("LABEL_NO_vocabulario_referencia","no se encuentran vocabularios de referencia para establer relacin terminolgica");
define("FORM_LABEL_tipo_equivalencia","tipo de equivalencia");
define("LABEL_vocabulario_principal","vocabulario");
define("LABEL_tipo_vocabulario","tipo");

define("LABEL_termino_equivalente","equivale");
define("LABEL_termino_parcial_equivalente","equivale parcialmente");
define("LABEL_termino_no_equivalente","no equivale");

define("EQ_acronimo","EQ");
define("EQP_acronimo","EQP");
define("NEQ_acronimo","NEQ");
define("LABEL_NC","Nota de catalogacin");

define("LABEL_resultados_suplementarios","resultados suplementarios");
define("LABEL_resultados_relacionados","resultados relacionados");

/* v 9.7 */
define("LABEL_export","exportar");
define("FORM_LABEL_format_export","seleccionar esquema XML");
define("LABEL_siteMap","SiteMap");
define("LABEL_TotalTopicMap","exportar en TopicMap");


/* v 1.0 */
define("LABEL_fecha_creacion","creado");
define("NB_acronimo","NB");
define("NH_acronimo","NH");
define("NA_acronimo","NA");
define("NP_acronimo","NP");
define("NC_acronimo","NC");

define("LABEL_Candidato","trmino candidato");
define("LABEL_Aceptado","trmino aceptado");
define("LABEL_Rechazado","trmino rechazado");
define("LABEL_Ultimos_aceptados","aceptados recientes");
define("MSG_ERROR_ESTADO","Estado no aceptable");

define("LABEL_Candidatos","trmino candidatos");
define("LABEL_Aceptados","trmino aceptados");
define("LABEL_Rechazados","trmino rechazados");

define("LABEL_User_NoHabilitado","no habilitado");
define("LABEL_User_Habilitado","habilitado");


?>
